import r from '../modules/renderer';
import h from '../modules/listeners';
import m from '../modules/methods'

const initAtt = (that, options) => {
	that.options = options || {};
	that.selected = Array.isArray(that.val())? that.val() : that.val() ? [that.val()] : [];
	that.isMultiple = that.prop('multiple');
	//undefined项在初始化完成后会被赋值
	that.selector = undefined;
	that.shower = undefined;
	that.downer = undefined;
	that.size = {};
};
const initDom = (that) => {
	//渲染外壳
	r.renderShell(that);
	//处理select标签
	that.hide();
	r.selected(that);
	//渲染选项
	r.renderOptions(that, [].map.call(that.find('option'), (v) => {
		return {text: $(v).html(), value: $(v).val()};
	}));
	r.syncOptions(that);
};

const initListeners = (that) => {
	//鼠标点击展开收起
	that.selector.on('click', '.shower', function () {
		h.spreadAndFold(that.selector);
	})
	//点击li标签
		.on('click', 'li:not(.search)', function () {
			h.clickLi(that, $(this));
		})
		//点击关闭按钮
		.on('click', '.close', function (e) {
			e.stopPropagation();
			h.clickClose(that, $(this));
		})
		.on('input', '.search input', function () {
			h.input(that, $(this).val());
		});
};

const initTheme = (that)=>{
	m.resetTheme(that);
};

const initializers = (that, options) => {
	initAtt(that, options);
	initDom(that);
	initListeners(that);
	initTheme(that);
};
export default initializers;