import m from './methods';
import r from './renderer';

const handlers = {
	spreadAndFold: ($selector) => {
		const isOpen = $selector.hasClass('open');
		if (isOpen) {
			$selector.find('ul').slideUp(() => {
				$selector.toggleClass('open');
			});
		} else {
			$selector.toggleClass('open');
			$selector.find('ul').slideDown();
		}
	},
	clickLi: (that, $li) => {
		$li.toggleClass('selected');
		if ($li.hasClass('selected')) {
			if (!that.isMultiple) {
				//单选
				m.clearData(that, false);
				$li.siblings().removeClass('selected');
				handlers.spreadAndFold(that.selector);
			}
			m.addData(that, $li, true);
		} else {
			m.removeData(that, $li, true);
		}

		r.selected(that);
		m.resetTheme(that);
	},
	clickClose: (that, $close) => {
		$close.closest('.selected_item').remove();
		m.removeData(that, $close.data('value'));
		//这里本可以只渲染options,selected直接移除点击的就行了
		//但是当全都删掉之后，不会自动渲染'请选择'
		//所以还是直接调用渲染选项的方法，数据驱动吧
		r.selected(that);
		r.syncOptions(that);
	},
	input: (that, val) => {
		const remote = that.options.remote;
		const run = () => {
			if (remote) {
				$.get(remote.url, { value: val }, (res) => {
					if (remote.format) res = remote.format(res);
					r.renderOptions(that, res);
					r.syncOptions(that);
					m.resetTheme(that);
				});
			} else {
				that.downer.find('li:not(.search)').each((k, v) => {
					if ($(v).find('.selector_text').html().includes(val)) {
						$(v).show();
					} else {
						$(v).hide();
					}
				});
			}
			clearTimeout(that.timeId);
		};
		//延迟搜索，优化性能。默认延迟300ms
		let delay = remote.delay || 300;
		clearTimeout(that.timeId);
		that.timeId = setTimeout(run, delay);
	}
};

export default handlers;