import template from '../templates/main.art.html';
import optionsTpl from '../templates/options.art.html';
import shower from '../templates/shower.art.html';
import m from './methods';

const renderer = {
	selected: (that) => {
		//生成选中模板
		const html = shower({
			data: m.parseSelected(that),
			allowClose:!(that.options.allowClose === false)
		});
		//渲染
		that.shower.html(html);
		//每次渲染选中项都要重新适配高度
		m.heightAdaptor(that);
	},
	syncOptions: (that) => {
		//li标签同步
		that.downer.find('li:not(.search)').each((k, v) => {
			if (that.selected.includes($(v).find('.selector_text').data('value').toString())) {
				$(v).addClass('itemColor');
			} else {
				$(v).removeClass('itemColor');
			}
		});
	},
	renderShell: (that) => {
		const shellHtmlStr = template({
			name: that.name,
			title: that.options.title,
			search: that.options.search
		});
		//渲染并记入属性
		that.selector = $(shellHtmlStr).insertAfter(that);
		that.shower = that.selector.find('.shower');
		that.downer = that.selector.find('.downer');
	},
	renderOptions: (that, data = []) => {
		//检查额外的数据----远程搜索返回的数据select标签中缺失
		//补上option标签
		const compareValues = [].map.call(that.find('option'), (v) => {
			return $(v).val().toString();
		});
		data.forEach((v) => {
			if (!compareValues.includes(v.value)) {
				that.append($(`<option value="${v.value}">${v.text}</option>`));
			}
		});


		const optionsHtmlStr = optionsTpl({
			options: data
		});
		that.downer.find('.options_container').html(optionsHtmlStr);
		//每次渲染选中项都要重新适配高度
		m.heightAdaptor(that, data);
	},

};
export default renderer;